/*
 * flawd.h
 *
 * Copyright Stephen C. Tweedie, 1997 
 *
 * Redistribution of this file is permitted under the GNU Public
 * License.
 */

#include <asm/ioctl.h>
#include <linux/kdev_t.h>

/*
 * Choose a block device major number...
 */
#define FLAWD_MAJOR 63

/*
 * How many flawd devices to support?
 */
#define NR_FLAWD_MINOR 4

#define LinuxVersionCode(v, p, s) (((v)<<16)+((p)<<8)+(s))

#ifdef __KERNEL__

#if LINUX_VERSION_CODE >= LinuxVersionCode(2,1,0)
#define RELEASE_RET_TYPE int
#define RELEASE_RETURN return 0
#else 
#define RELEASE_RET_TYPE void
#define RELEASE_RETURN return
#endif

/*
 * Header data structure for a flawd device
 */

struct flawd_device 
{
	kdev_t		devnr;
	int		refcnt;
	
	int		nr_sectors;
	int		nr_bytes;

	char		*data;
	char		*bad_block_map;
};

static void do_flawd_request(void);

#endif

/*
 * IOCTL commands
 */

typedef struct __flawd_sector_range
{
	int	start;
	int	count;
} __FLAWD_SECTOR_RANGE;

#define FLAWD_SET_BAD_SECTORS	_IOW ('f', 0x80, __FLAWD_SECTOR_RANGE)
#define FLAWD_CLEAR_BAD_SECTORS	_IOW ('f', 0x81, __FLAWD_SECTOR_RANGE)
